*** a/src/backend/catalog/pg_aggregate.c
--- b/src/backend/catalog/pg_aggregate.c
***************
*** 46,51 **** Oid
--- 46,52 ----
  AggregateCreate(const char *aggName,
  				Oid aggNamespace,
  				int numArgs,
+ 				int numDirectArgs,
  				oidvector *parameterTypes,
  				Datum allParameterTypes,
  				Datum parameterModes,
***************
*** 54,77 **** AggregateCreate(const char *aggName,
  				List *aggtransfnName,
  				List *aggfinalfnName,
  				List *aggsortopName,
  				Oid aggTransType,
! 				const char *agginitval)
  {
  	Relation	aggdesc;
  	HeapTuple	tup;
  	bool		nulls[Natts_pg_aggregate];
  	Datum		values[Natts_pg_aggregate];
  	Form_pg_proc proc;
! 	Oid			transfn;
  	Oid			finalfn = InvalidOid;	/* can be omitted */
  	Oid			sortop = InvalidOid;	/* can be omitted */
  	Oid		   *aggArgTypes = parameterTypes->values;
  	bool		hasPolyArg;
  	bool		hasInternalArg;
  	Oid			rettype;
  	Oid			finaltype;
! 	Oid		   *fnArgs;
! 	int			nargs_transfn;
  	Oid			procOid;
  	TupleDesc	tupDesc;
  	int			i;
--- 55,83 ----
  				List *aggtransfnName,
  				List *aggfinalfnName,
  				List *aggsortopName,
+ 				List *aggtranssortopName,
  				Oid aggTransType,
! 				const char *agginitval,
! 				bool isStrict,
! 				bool isOrderedSet,
! 				bool isHypotheticalSet)
  {
  	Relation	aggdesc;
  	HeapTuple	tup;
  	bool		nulls[Natts_pg_aggregate];
  	Datum		values[Natts_pg_aggregate];
  	Form_pg_proc proc;
! 	Oid			transfn = InvalidOid;	/* can be omitted */
  	Oid			finalfn = InvalidOid;	/* can be omitted */
  	Oid			sortop = InvalidOid;	/* can be omitted */
+ 	Oid			transsortop = InvalidOid;  /* Can be omitted */
  	Oid		   *aggArgTypes = parameterTypes->values;
  	bool		hasPolyArg;
  	bool		hasInternalArg;
+ 	Oid         variadic_type = InvalidOid;
  	Oid			rettype;
  	Oid			finaltype;
! 	Oid		   *fnArgs = palloc((numArgs + 1) * sizeof(Oid));
  	Oid			procOid;
  	TupleDesc	tupDesc;
  	int			i;
***************
*** 83,90 **** AggregateCreate(const char *aggName,
  	if (!aggName)
  		elog(ERROR, "no aggregate name supplied");
  
! 	if (!aggtransfnName)
! 		elog(ERROR, "aggregate must have a transition function");
  
  	/* check for polymorphic and INTERNAL arguments */
  	hasPolyArg = false;
--- 89,108 ----
  	if (!aggName)
  		elog(ERROR, "no aggregate name supplied");
  
! 	if (isOrderedSet)
! 	{
! 		if (aggtransfnName)
! 			elog(ERROR, "Ordered set functions cannot have transition functions");
! 		if (!aggfinalfnName)
! 			elog(ERROR, "Ordered set functions must have final functions");
! 	}
! 	else
! 	{
! 		if (!aggtransfnName)
! 			elog(ERROR, "aggregate must have a transition function");
! 		if (isStrict)
! 			elog(ERROR, "aggregate with transition function must not be explicitly STRICT");
! 	}
  
  	/* check for polymorphic and INTERNAL arguments */
  	hasPolyArg = false;
***************
*** 97,102 **** AggregateCreate(const char *aggName,
--- 115,250 ----
  			hasInternalArg = true;
  	}
  
+ 	/*-
+ 	 * Argument mode checks. If there were no variadics, we should have been
+ 	 * passed a NULL pointer for parameterModes, so we can skip this if so.
+ 	 * Otherwise, the allowed cases are as follows:
+ 	 *
+ 	 * aggfn(..., variadic sometype)   - normal agg with variadic arg last
+ 	 * aggfn(..., variadic "any")      - normal agg with "any" variadic
+ 	 *
+ 	 * ordfn(..., variadic "any") within group (*)
+ 	 *  - ordered set func with "any" variadic in direct args, which requires
+ 	 *    that the ordered args also be variadic any which we represent
+ 	 *    specially; this is the common case for hypothetical set functions.
+ 	 *    Note this is the only case where numDirectArgs == numArgs on input
+ 	 *    (implies finalfn(..., variadic "any"))
+ 	 *
+ 	 * ordfn(...) within group (..., variadic "any")
+ 	 *  - ordered set func with no variadic in direct args, but allowing any
+ 	 *    types of ordered args.
+ 	 *    (implies finalfn(..., ..., variadic "any"))
+ 	 *
+ 	 * We don't allow variadic ordered args other than "any"; we don't allow
+ 	 * anything after variadic "any" except the special-case (*).
+ 	 *
+ 	 * We might like to support this one:
+ 	 *
+ 	 * ordfn(..., variadic sometype) within group (...)
+ 	 *  - ordered set func with variadic direct arg last, followed by ordered
+ 	 *    args, none of which are variadic
+ 	 *    (implies finalfn(..., sometype, ..., [transtype]))
+ 	 *
+ 	 * but currently it seems to be too intrusive to do so; the assumption
+ 	 * that variadic args can only come last is quite widespread.
+ 	 */
+ 
+ 	if (parameterModes != PointerGetDatum(NULL))
+ 	{
+ 		/*
+ 		 * We expect the array to be a 1-D CHAR array; verify that. We don't
+ 		 * need to use deconstruct_array() since the array data is just going
+ 		 * to look like a C array of char values.
+ 		 */
+ 		ArrayType  *modesArray = (ArrayType *) DatumGetPointer(parameterModes);
+ 		char       *paramModes;
+ 		int         modesCount;
+ 		int         i;
+ 
+ 		if (ARR_NDIM(modesArray) != 1 ||
+ 			ARR_HASNULL(modesArray) ||
+ 			ARR_ELEMTYPE(modesArray) != CHAROID)
+ 			elog(ERROR, "parameterModes is not a 1-D char array");
+ 
+ 		paramModes = (char *) ARR_DATA_PTR(modesArray);
+ 		modesCount = ARR_DIMS(modesArray)[0];
+ 
+ 		for (i = 0; i < modesCount; ++i)
+ 		{
+ 			switch (paramModes[i])
+ 			{
+ 				case PROARGMODE_VARIADIC:
+ 					if (OidIsValid(variadic_type))
+ 						ereport(ERROR,
+ 								(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 								 errmsg("VARIADIC must not be specified more than once")));
+ 					variadic_type = aggArgTypes[i];
+ 
+ 					/* enforce restrictions on ordered args */
+ 
+ 					if (numDirectArgs >= 0
+ 						&& i >= numDirectArgs
+ 						&& variadic_type != ANYOID)
+ 						ereport(ERROR,
+ 								(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 								 errmsg("VARIADIC ordered arguments must be of type ANY")));
+ 
+ 					break;
+ 
+ 				case PROARGMODE_IN:
+ 					if (OidIsValid(variadic_type))
+ 						ereport(ERROR,
+ 								(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 								 errmsg("VARIADIC argument must be last")));
+ 					break;
+ 
+ 				default:
+ 					elog(ERROR, "invalid argument mode");
+ 			}
+ 		}
+ 	}
+ 
+ 	switch (variadic_type)
+ 	{
+ 		case InvalidOid:
+ 		case ANYARRAYOID:
+ 		case ANYOID:
+ 			/* okay */
+ 			break;
+ 		default:
+ 			if (!OidIsValid(get_element_type(variadic_type)))
+ 				elog(ERROR, "VARIADIC parameter must be an array");
+ 			break;
+ 	}
+ 
+ 	if (isHypotheticalSet)
+ 	{
+ 		if (numArgs != numDirectArgs
+ 			|| variadic_type != ANYOID)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 					 errmsg("Invalid argument types for hypothetical set function"),
+ 					 errhint("Required declaration is (..., VARIADIC \"any\") WITHIN GROUP (*)")));
+ 
+ 		/* flag for special processing for hypothetical sets */
+ 		numDirectArgs = -2;
+ 	}
+ 	else if (numArgs == numDirectArgs)
+ 	{
+ 		if (variadic_type == ANYOID)
+ 		{
+ 			/*
+ 			 * this case allows the number of direct args to be truly variable
+ 			 */
+ 			numDirectArgs = -1;
+ 		}
+ 		else
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 					 errmsg("Invalid argument types for ordered set function"),
+ 					 errhint("WITHIN GROUP (*) is not allowed without VARIADIC \"any\"")));
+ 	}
+ 
  	/*
  	 * If transtype is polymorphic, must have polymorphic argument also; else
  	 * we will have no way to deduce the actual transtype.
***************
*** 107,159 **** AggregateCreate(const char *aggName,
  				 errmsg("cannot determine transition data type"),
  				 errdetail("An aggregate using a polymorphic transition type must have at least one polymorphic argument.")));
  
! 	/* find the transfn */
! 	nargs_transfn = numArgs + 1;
! 	fnArgs = (Oid *) palloc(nargs_transfn * sizeof(Oid));
! 	fnArgs[0] = aggTransType;
! 	memcpy(fnArgs + 1, aggArgTypes, numArgs * sizeof(Oid));
! 	transfn = lookup_agg_function(aggtransfnName, nargs_transfn, fnArgs,
! 								  &rettype);
  
! 	/*
! 	 * Return type of transfn (possibly after refinement by
! 	 * enforce_generic_type_consistency, if transtype isn't polymorphic) must
! 	 * exactly match declared transtype.
! 	 *
! 	 * In the non-polymorphic-transtype case, it might be okay to allow a
! 	 * rettype that's binary-coercible to transtype, but I'm not quite
! 	 * convinced that it's either safe or useful.  When transtype is
! 	 * polymorphic we *must* demand exact equality.
! 	 */
! 	if (rettype != aggTransType)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_DATATYPE_MISMATCH),
! 				 errmsg("return type of transition function %s is not %s",
! 						NameListToString(aggtransfnName),
! 						format_type_be(aggTransType))));
  
! 	tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(transfn));
! 	if (!HeapTupleIsValid(tup))
! 		elog(ERROR, "cache lookup failed for function %u", transfn);
! 	proc = (Form_pg_proc) GETSTRUCT(tup);
  
! 	/*
! 	 * If the transfn is strict and the initval is NULL, make sure first input
! 	 * type and transtype are the same (or at least binary-compatible), so
! 	 * that it's OK to use the first input value as the initial transValue.
! 	 */
! 	if (proc->proisstrict && agginitval == NULL)
! 	{
! 		if (numArgs < 1 ||
! 			!IsBinaryCoercible(aggArgTypes[0], aggTransType))
  			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("must not omit initial value when transition function is strict and transition type is not compatible with input type")));
  	}
- 	ReleaseSysCache(tup);
  
  	/* handle finalfn, if supplied */
! 	if (aggfinalfnName)
  	{
  		fnArgs[0] = aggTransType;
  		finalfn = lookup_agg_function(aggfinalfnName, 1, fnArgs,
--- 255,340 ----
  				 errmsg("cannot determine transition data type"),
  				 errdetail("An aggregate using a polymorphic transition type must have at least one polymorphic argument.")));
  
! 	if (!isOrderedSet)
! 	{
! 		/* find the transfn */		
  
! 		fnArgs[0] = aggTransType;
! 		memcpy(fnArgs + 1, aggArgTypes, numArgs * sizeof(Oid));
  
! 		transfn = lookup_agg_function(aggtransfnName, numArgs + 1, fnArgs,
! 									  &rettype);
  
! 		/*
! 		 * Return type of transfn (possibly after refinement by
! 		 * enforce_generic_type_consistency, if transtype isn't polymorphic)
! 		 * must exactly match declared transtype.
! 		 *
! 		 * In the non-polymorphic-transtype case, it might be okay to allow a
! 		 * rettype that's binary-coercible to transtype, but I'm not quite
! 		 * convinced that it's either safe or useful.  When transtype is
! 		 * polymorphic we *must* demand exact equality.
! 		 */
! 		if (rettype != aggTransType)
  			ereport(ERROR,
! 					(errcode(ERRCODE_DATATYPE_MISMATCH),
! 					 errmsg("return type of transition function %s is not %s",
! 							NameListToString(aggtransfnName),
! 							format_type_be(aggTransType))));
! 
! 		tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(transfn));
! 		if (!HeapTupleIsValid(tup))
! 			elog(ERROR, "cache lookup failed for function %u", transfn);
! 		proc = (Form_pg_proc) GETSTRUCT(tup);
! 
! 		/*
! 	 	 * If the transfn is strict and the initval is NULL, make sure first
! 	 	 * input type and transtype are the same (or at least
! 	 	 * binary-compatible), so that it's OK to use the first input value as
! 	 	 * the initial transValue.
! 	 	 */
! 		if (proc->proisstrict && agginitval == NULL)
! 		{
! 			if (numArgs < 1 ||
! 				!IsBinaryCoercible(aggArgTypes[0], aggTransType))
! 				ereport(ERROR,
! 						(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 						 errmsg("must not omit initial value when transition function is strict and transition type is not compatible with input type")));
! 		}
! 		ReleaseSysCache(tup);
  	}
  
  	/* handle finalfn, if supplied */
! 	if (isOrderedSet)
! 	{
! 		int num_final_args = numArgs;
! 
! 		memcpy(fnArgs, aggArgTypes, num_final_args * sizeof(Oid));
! 
! 		/*
! 		 * If there's a transtype, it becomes the last arg to the finalfn;
! 		 * but if the agg (and hence the finalfn) is variadic "any", then
! 		 * this contributes nothing to the signature.
! 		 */
! 		if (aggTransType != InvalidOid && variadic_type != ANYOID)
! 			fnArgs[num_final_args++] = aggTransType;
! 
! 		finalfn = lookup_agg_function(aggfinalfnName, num_final_args, fnArgs,
! 									  &finaltype);
! 
! 		/*
! 		 * this is also checked at runtime for security reasons, but check
! 		 * here too to provide a friendly error (the requirement is because
! 		 * the finalfn will be passed null dummy args for type resolution
! 		 * purposes)
! 		 */
! 
! 		if (func_strict(finalfn))
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("ordered set final functions must not be declared STRICT")));
! 	}
! 	else if (aggfinalfnName)
  	{
  		fnArgs[0] = aggTransType;
  		finalfn = lookup_agg_function(aggfinalfnName, 1, fnArgs,
***************
*** 166,171 **** AggregateCreate(const char *aggName,
--- 347,353 ----
  		 */
  		finaltype = aggTransType;
  	}
+ 
  	Assert(OidIsValid(finaltype));
  
  	/*
***************
*** 207,212 **** AggregateCreate(const char *aggName,
--- 389,406 ----
  								false, -1);
  	}
  
+ 	/* handle transsortop, if supplied */
+ 	if (aggtranssortopName)
+ 	{
+ 		if (!isOrderedSet || !OidIsValid(aggTransType))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 					 errmsg("transition sort operator can only be specified for ordered set functions with transition types")));
+ 		transsortop = LookupOperName(NULL, aggtranssortopName,
+ 									 aggTransType, aggTransType,
+ 									 false, -1);
+ 	}
+ 
  	/*
  	 * permission checks on used types
  	 */
***************
*** 217,231 **** AggregateCreate(const char *aggName,
  			aclcheck_error_type(aclresult, aggArgTypes[i]);
  	}
  
! 	aclresult = pg_type_aclcheck(aggTransType, GetUserId(), ACL_USAGE);
! 	if (aclresult != ACLCHECK_OK)
! 		aclcheck_error_type(aclresult, aggTransType);
  
  	aclresult = pg_type_aclcheck(finaltype, GetUserId(), ACL_USAGE);
  	if (aclresult != ACLCHECK_OK)
  		aclcheck_error_type(aclresult, finaltype);
  
- 
  	/*
  	 * Everything looks okay.  Try to create the pg_proc entry for the
  	 * aggregate.  (This could fail if there's already a conflicting entry.)
--- 411,427 ----
  			aclcheck_error_type(aclresult, aggArgTypes[i]);
  	}
  
! 	if (OidIsValid(aggTransType))
! 	{
! 		aclresult = pg_type_aclcheck(aggTransType, GetUserId(), ACL_USAGE);
! 		if (aclresult != ACLCHECK_OK)
! 			aclcheck_error_type(aclresult, aggTransType);
! 	}
  
  	aclresult = pg_type_aclcheck(finaltype, GetUserId(), ACL_USAGE);
  	if (aclresult != ACLCHECK_OK)
  		aclcheck_error_type(aclresult, finaltype);
  
  	/*
  	 * Everything looks okay.  Try to create the pg_proc entry for the
  	 * aggregate.  (This could fail if there's already a conflicting entry.)
***************
*** 246,252 **** AggregateCreate(const char *aggName,
  							  false,	/* security invoker (currently not
  										 * definable for agg) */
  							  false,	/* isLeakProof */
! 							  false,	/* isStrict (not needed for agg) */
  							  PROVOLATILE_IMMUTABLE,	/* volatility (not
  														 * needed for agg) */
  							  parameterTypes,	/* paramTypes */
--- 442,448 ----
  							  false,	/* security invoker (currently not
  										 * definable for agg) */
  							  false,	/* isLeakProof */
! 							  isStrict,	/* isStrict (needed for ordered set funcs) */
  							  PROVOLATILE_IMMUTABLE,	/* volatility (not
  														 * needed for agg) */
  							  parameterTypes,	/* paramTypes */
***************
*** 272,278 **** AggregateCreate(const char *aggName,
--- 468,478 ----
  	values[Anum_pg_aggregate_aggtransfn - 1] = ObjectIdGetDatum(transfn);
  	values[Anum_pg_aggregate_aggfinalfn - 1] = ObjectIdGetDatum(finalfn);
  	values[Anum_pg_aggregate_aggsortop - 1] = ObjectIdGetDatum(sortop);
+ 	values[Anum_pg_aggregate_aggtranssortop - 1] = ObjectIdGetDatum(transsortop);
  	values[Anum_pg_aggregate_aggtranstype - 1] = ObjectIdGetDatum(aggTransType);
+ 	values[Anum_pg_aggregate_aggordnargs - 1] = Int32GetDatum(numDirectArgs);
+ 	values[Anum_pg_aggregate_aggisordsetfunc - 1] = BoolGetDatum(isOrderedSet);
+ 
  	if (agginitval)
  		values[Anum_pg_aggregate_agginitval - 1] = CStringGetTextDatum(agginitval);
  	else
***************
*** 290,307 **** AggregateCreate(const char *aggName,
  
  	/*
  	 * Create dependencies for the aggregate (above and beyond those already
! 	 * made by ProcedureCreate).  Note: we don't need an explicit dependency
! 	 * on aggTransType since we depend on it indirectly through transfn.
  	 */
  	myself.classId = ProcedureRelationId;
  	myself.objectId = procOid;
  	myself.objectSubId = 0;
  
  	/* Depends on transition function */
! 	referenced.classId = ProcedureRelationId;
! 	referenced.objectId = transfn;
! 	referenced.objectSubId = 0;
! 	recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
  
  	/* Depends on final function, if any */
  	if (OidIsValid(finalfn))
--- 490,512 ----
  
  	/*
  	 * Create dependencies for the aggregate (above and beyond those already
! 	 * made by ProcedureCreate).  Normal aggs don't need an explicit
! 	 * dependency on aggTransType since we depend on it indirectly through
! 	 * transfn, but ordered set functions with variadic "any" do need one
! 	 * (ordered set functions without variadic depend on it via the finalfn).
  	 */
  	myself.classId = ProcedureRelationId;
  	myself.objectId = procOid;
  	myself.objectSubId = 0;
  
  	/* Depends on transition function */
! 	if (OidIsValid(transfn))
! 	{
! 		referenced.classId = ProcedureRelationId;
! 		referenced.objectId = transfn;
! 		referenced.objectSubId = 0;
! 		recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
! 	}
  
  	/* Depends on final function, if any */
  	if (OidIsValid(finalfn))
***************
*** 321,326 **** AggregateCreate(const char *aggName,
--- 526,549 ----
  		recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
  	}
  
+ 	/* Depends on transsort operator, if any */
+ 	if (OidIsValid(transsortop))
+ 	{
+ 		referenced.classId = OperatorRelationId;
+ 		referenced.objectId = transsortop;
+ 		referenced.objectSubId = 0;
+ 		recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
+ 	}
+ 
+ 	/* May depend on aggTransType if any */
+ 	if (OidIsValid(aggTransType) && isOrderedSet && variadic_type == ANYOID)
+ 	{
+ 		referenced.classId = TypeRelationId;
+ 		referenced.objectId = aggTransType;
+ 		referenced.objectSubId = 0;
+ 		recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
+ 	}
+ 
  	return procOid;
  }
  
*** a/src/backend/commands/aggregatecmds.c
--- b/src/backend/commands/aggregatecmds.c
***************
*** 44,52 ****
   *	DefineAggregate
   *
   * "oldstyle" signals the old (pre-8.2) style where the aggregate input type
!  * is specified by a BASETYPE element in the parameters.  Otherwise,
!  * "args" is a list of FunctionParameter structs defining the agg's arguments.
!  * "parameters" is a list of DefElem representing the agg's definition clauses.
   */
  Oid
  DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
--- 44,55 ----
   *	DefineAggregate
   *
   * "oldstyle" signals the old (pre-8.2) style where the aggregate input type
!  * is specified by a BASETYPE element in the parameters.  Otherwise, "args" is
!  * a pair, whose first element is a list of FunctionParameter structs defining
!  * the agg's arguments (both direct and ordered), and whose second element is
!  * an Integer node with the number of direct args, or -1 if this isn't an
!  * ordered set func.  "parameters" is a list of DefElem representing the agg's
!  * definition clauses.
   */
  Oid
  DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
***************
*** 58,75 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  	List	   *transfuncName = NIL;
  	List	   *finalfuncName = NIL;
  	List	   *sortoperatorName = NIL;
  	TypeName   *baseType = NULL;
  	TypeName   *transType = NULL;
  	char	   *initval = NULL;
  	int			numArgs;
  	oidvector  *parameterTypes;
  	ArrayType  *allParameterTypes;
  	ArrayType  *parameterModes;
  	ArrayType  *parameterNames;
  	List	   *parameterDefaults;
- 	Oid			transTypeId;
  	char		transTypeType;
  	ListCell   *pl;
  
  	/* Convert list of names to a name and namespace */
  	aggNamespace = QualifiedNameGetCreationNamespace(name, &aggName);
--- 61,83 ----
  	List	   *transfuncName = NIL;
  	List	   *finalfuncName = NIL;
  	List	   *sortoperatorName = NIL;
+ 	List	   *transsortoperatorName = NIL;
  	TypeName   *baseType = NULL;
  	TypeName   *transType = NULL;
  	char	   *initval = NULL;
  	int			numArgs;
+ 	int			numDirectArgs = -1;
+ 	Oid			transTypeId = InvalidOid;
  	oidvector  *parameterTypes;
  	ArrayType  *allParameterTypes;
  	ArrayType  *parameterModes;
  	ArrayType  *parameterNames;
  	List	   *parameterDefaults;
  	char		transTypeType;
  	ListCell   *pl;
+ 	bool		ishypothetical = false;
+ 	bool		isOrderedSet = false;
+ 	bool		isStrict = false;
  
  	/* Convert list of names to a name and namespace */
  	aggNamespace = QualifiedNameGetCreationNamespace(name, &aggName);
***************
*** 80,85 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
--- 88,101 ----
  		aclcheck_error(aclresult, ACL_KIND_NAMESPACE,
  					   get_namespace_name(aggNamespace));
  
+ 	Assert(args == NIL || list_length(args) == 2);
+ 
+ 	if (list_length(args) == 2)
+ 	{
+ 		numDirectArgs = intVal(lsecond(args));
+ 		isOrderedSet = (numDirectArgs != -1);
+ 	}
+ 
  	foreach(pl, parameters)
  	{
  		DefElem    *defel = (DefElem *) lfirst(pl);
***************
*** 106,111 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
--- 122,133 ----
  			initval = defGetString(defel);
  		else if (pg_strcasecmp(defel->defname, "initcond1") == 0)
  			initval = defGetString(defel);
+ 		else if (pg_strcasecmp(defel->defname, "hypothetical") == 0)
+ 			ishypothetical = true;
+ 		else if (pg_strcasecmp(defel->defname, "strict") == 0)
+ 			isStrict = true;
+ 		else if (pg_strcasecmp(defel->defname, "transsortop") == 0)
+ 			transsortoperatorName = defGetQualifiedName(defel);
  		else
  			ereport(WARNING,
  					(errcode(ERRCODE_SYNTAX_ERROR),
***************
*** 113,129 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  							defel->defname)));
  	}
  
! 	/*
! 	 * make sure we have our required definitions
! 	 */
! 	if (transType == NULL)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 				 errmsg("aggregate stype must be specified")));
! 	if (transfuncName == NIL)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 				 errmsg("aggregate sfunc must be specified")));
  
  	/*
  	 * look up the aggregate's input datatype(s).
--- 135,169 ----
  							defel->defname)));
  	}
  
! 	if (!isOrderedSet)
! 	{
! 		/*
! 		 * make sure we have our required definitions
! 		 */
! 		if (transType == NULL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 						errmsg("aggregate stype must be specified")));
! 		if (transfuncName == NIL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("aggregate sfunc must be specified")));
! 		if (isStrict)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("aggregate with sfunc must not be explicitly declared STRICT")));
! 	}
! 	else
! 	{
! 		if (transfuncName != NIL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("sfunc must not be specified for ordered set functions")));
! 		if (finalfuncName == NIL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("finalfunc must be specified for ordered set functions")));
! 	}
  
  	/*
  	 * look up the aggregate's input datatype(s).
***************
*** 173,180 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
  					 errmsg("basetype is redundant with aggregate input type specification")));
  
! 		numArgs = list_length(args);
! 		interpret_function_parameter_list(args,
  										  InvalidOid,
  										  true, /* is an aggregate */
  										  queryString,
--- 213,227 ----
  					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
  					 errmsg("basetype is redundant with aggregate input type specification")));
  
! 		/*
! 		 * The grammar has already concatenated the direct and ordered
! 		 * args (if any) for us. Note that error checking for position
! 		 * and number of VARIADIC args is not done for us, we have to
! 		 * do it ourselves later (in AggregateCreate)
! 		 */
! 
! 		numArgs = list_length(linitial(args));
! 		interpret_function_parameter_list(linitial(args),
  										  InvalidOid,
  										  true, /* is an aggregate */
  										  queryString,
***************
*** 191,197 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  	}
  
  	/*
! 	 * look up the aggregate's transtype.
  	 *
  	 * transtype can't be a pseudo-type, since we need to be able to store
  	 * values of the transtype.  However, we can allow polymorphic transtype
--- 238,244 ----
  	}
  
  	/*
! 	 * look up the aggregate's transtype, if specified.
  	 *
  	 * transtype can't be a pseudo-type, since we need to be able to store
  	 * values of the transtype.  However, we can allow polymorphic transtype
***************
*** 201,218 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  	 * worse) by connecting up incompatible internal-using functions in an
  	 * aggregate.
  	 */
! 	transTypeId = typenameTypeId(NULL, transType);
! 	transTypeType = get_typtype(transTypeId);
! 	if (transTypeType == TYPTYPE_PSEUDO &&
! 		!IsPolymorphicType(transTypeId))
  	{
! 		if (transTypeId == INTERNALOID && superuser())
! 			 /* okay */ ;
! 		else
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					 errmsg("aggregate transition data type cannot be %s",
! 							format_type_be(transTypeId))));
  	}
  
  	/*
--- 248,267 ----
  	 * worse) by connecting up incompatible internal-using functions in an
  	 * aggregate.
  	 */
! 	if (transType)
  	{
! 		transTypeId = typenameTypeId(NULL, transType);
! 		transTypeType = get_typtype(transTypeId);
! 		if (transTypeType == TYPTYPE_PSEUDO &&
! 			!IsPolymorphicType(transTypeId))
! 		{
! 			if (transTypeId != INTERNALOID || !superuser() || isOrderedSet)
! 				ereport(ERROR,
! 						(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 						 errmsg("aggregate transition data type cannot be %s",
! 								format_type_be(transTypeId))));
! 		}
! 
  	}
  
  	/*
***************
*** 224,236 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  	 * value.  However, if it's an incorrect value it seems much more
  	 * user-friendly to complain at CREATE AGGREGATE time.
  	 */
! 	if (initval && transTypeType != TYPTYPE_PSEUDO)
  	{
! 		Oid			typinput,
! 					typioparam;
  
! 		getTypeInputInfo(transTypeId, &typinput, &typioparam);
! 		(void) OidInputFunctionCall(typinput, initval, typioparam, -1);
  	}
  
  	/*
--- 273,295 ----
  	 * value.  However, if it's an incorrect value it seems much more
  	 * user-friendly to complain at CREATE AGGREGATE time.
  	 */
! 	if (transType)
  	{
! 		if (initval && transTypeType != TYPTYPE_PSEUDO)
! 		{
! 			Oid			typinput,
! 						typioparam;
  
! 			getTypeInputInfo(transTypeId, &typinput, &typioparam);
! 			(void) OidInputFunctionCall(typinput, initval, typioparam, -1);
! 		}
! 	}
! 	else
! 	{
! 		if (initval)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
! 					errmsg("INITVAL must not be specified without STYPE")));
  	}
  
  	/*
***************
*** 239,244 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
--- 298,304 ----
  	return AggregateCreate(aggName,		/* aggregate name */
  						   aggNamespace,		/* namespace */
  						   numArgs,
+ 						   numDirectArgs,
  						   parameterTypes,
  						   PointerGetDatum(allParameterTypes),
  						   PointerGetDatum(parameterModes),
***************
*** 247,252 **** DefineAggregate(List *name, List *args, bool oldstyle, List *parameters,
  						   transfuncName,		/* step function name */
  						   finalfuncName,		/* final function name */
  						   sortoperatorName,	/* sort operator name */
  						   transTypeId, /* transition data type */
! 						   initval);	/* initial condition */
  }
--- 307,316 ----
  						   transfuncName,		/* step function name */
  						   finalfuncName,		/* final function name */
  						   sortoperatorName,	/* sort operator name */
+ 						   transsortoperatorName,  /* transsort operator name */
  						   transTypeId, /* transition data type */
! 						   initval,  /* initial condition */
! 						   isStrict,  /* is explicitly STRICT */
! 						   isOrderedSet,  /* If the function is an ordered set */
! 						   ishypothetical);  /* If the function is a hypothetical set */
  }
*** a/src/backend/commands/functioncmds.c
--- b/src/backend/commands/functioncmds.c
***************
*** 274,281 **** interpret_function_parameter_list(List *parameters,
  		/* handle input parameters */
  		if (fp->mode != FUNC_PARAM_OUT && fp->mode != FUNC_PARAM_TABLE)
  		{
! 			/* other input parameters can't follow a VARIADIC parameter */
! 			if (varCount > 0)
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
  						 errmsg("VARIADIC parameter must be the last input parameter")));
--- 274,286 ----
  		/* handle input parameters */
  		if (fp->mode != FUNC_PARAM_OUT && fp->mode != FUNC_PARAM_TABLE)
  		{
! 			/*
! 			 * For functions, other input parameters can't follow a VARIADIC
! 			 * parameter; for aggregates, we might be dealing with an ordered
! 			 * set function which have more complex rules for variadics, so
! 			 * punt the error checking for that case to the caller.
! 			 */
! 			if (varCount > 0 && !is_aggregate)
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
  						 errmsg("VARIADIC parameter must be the last input parameter")));
*** a/src/backend/executor/execQual.c
--- b/src/backend/executor/execQual.c
***************
*** 4410,4415 **** ExecInitExpr(Expr *node, PlanState *parent)
--- 4410,4416 ----
  
  					astate->args = (List *) ExecInitExpr((Expr *) aggref->args,
  														 parent);
+ 					astate->orddirectargs = (List *) ExecInitExpr((Expr *) aggref->orddirectargs, parent);
  					astate->aggfilter = ExecInitExpr(aggref->aggfilter,
  													 parent);
  
*** a/src/backend/executor/functions.c
--- b/src/backend/executor/functions.c
***************
*** 380,387 **** sql_fn_post_column_ref(ParseState *pstate, ColumnRef *cref, Node *var)
  		param = ParseFuncOrColumn(pstate,
  								  list_make1(subfield),
  								  list_make1(param),
! 								  NIL, NULL, false, false, false,
! 								  NULL, true, cref->location);
  	}
  
  	return param;
--- 380,387 ----
  		param = ParseFuncOrColumn(pstate,
  								  list_make1(subfield),
  								  list_make1(param),
! 								  cref->location,
! 								  NULL);
  	}
  
  	return param;
